;;; File: "pfib.scm"

;; run with:
;;
;;   % gsi -e '(include "modules.scm")' pfib.scm 
;;
;; or compile and run with:
;;
;;   % gsc -e '(include "modules.scm")' pfib.scm
;;   % gsc -e '(include "modules.scm")' futures.scm
;;   % gsi -e '(include "modules.scm")' pfib

(##module pfib gambit)

(##require futures)

(define (pfib n)
  (if (< n 2)
      n
      (let* ((x (future (pfib (- n 1))))
             (y (pfib (- n 2))))
        (+ (touch x) y))))

(time (println "===> " (pfib 20)))
